/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ᥤ롼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Sep.14.1999  Programing start

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit       -- ᥤץʤ
  RRMain           -- ֤˥뤵ᥤ
  ChangeFace       -- ɽ̤Υ鳨򺹤ؤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <time.h>
#include <gtk/gtk.h>
#include  "rr_main.h"
#include  "rr_screen.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

/* --- եåǡ */
#include  "../picture/char01.xpm"
#include  "../picture/char02.xpm"
#include  "../picture/char03.xpm"
#include  "../picture/char04.xpm"
#include  "../picture/char05.xpm"

/* --- ɽ */
gchar  mth[12][4] = {
  "Jan", "Feb", "Mar", "Apr",
  "May", "Jun", "Jul", "Aug",
  "Sep", "Oct", "Nov", "Dec",
};


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  disp_time(void);
void  update_graphic(void);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

gint  timer;

/* --- ɽ륭饯 */
gint  face;
GdkPixmap *pic[5];
GdkBitmap *mask[5];


/* --- ִ */
time_t  tg;
struct tm       *ltime;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  timer = 0;
  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-26-*-*-*-*-*-*-*,\
                    -misc-fixed-medium-*-normal-*-24-*-*-*-*-*-jisx0208.1983-0");
  face = 0;

  /* -- եå pixmap  */
  pic[0] = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask[0],
					NULL,
					char01_xpm);
  pic[1] = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask[1],
					NULL,
					char02_xpm);
  pic[2] = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask[2],
					NULL,
					char03_xpm);
  pic[3] = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask[3],
					NULL,
					char04_xpm);
  pic[4] = gdk_pixmap_create_from_xpm_d(RRScreenCanvas()->window,
					&mask[4],
					NULL,
					char05_xpm);

  tg = time(NULL);

  /* -- ǥեȥեå */
  ChangeFace(face);

}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  gdk_pixmap_unref(pic[0]);
  gdk_pixmap_unref(pic[1]);
  gdk_pixmap_unref(pic[2]);
  gdk_pixmap_unref(pic[3]);
  gdk_pixmap_unref(pic[4]);
  gdk_bitmap_unref(mask[0]);
  gdk_bitmap_unref(mask[1]);
  gdk_bitmap_unref(mask[2]);
  gdk_bitmap_unref(mask[3]);
  gdk_bitmap_unref(mask[4]);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  if (tg != time(NULL)) {
    tg = time(NULL);
    update_graphic();
  }

  return 1;
}





/* -------------------------------------------------------------
  ChangeFace       -- ɽ̤Υ鳨򺹤ؤ

   return : void
   gint  ɽ륭饯ֹ
-------------------------------------------------------------- */
void ChangeFace(gint c_num)
{
  face = c_num;
  RRScreenPutPixmap(pic[face], 0, 0);
  disp_time();
}



/* -------------------------------------------------------------
  disp_time       -- ߻񤭹
-------------------------------------------------------------- */
void  disp_time(void)
{
  struct tm *timedata;
  gchar  date[64], time[64];

  timedata = localtime(&tg);
  sprintf(date, "%s.%02d.%4d", mth[timedata->tm_mon],
	  timedata->tm_mday, timedata->tm_year+1900);
  sprintf(time, "%02d:%02d:%02d", timedata->tm_hour,
	  timedata->tm_min, timedata->tm_sec);

  RRScreenGCColor(0, 0, 0);
  RRScreenFontLocate(10-1, 150);
  RRScreenFontPrint(date);
  RRScreenFontLocate(90-1, 180);
  RRScreenFontPrint(time);
  RRScreenFontLocate(10+1, 150);
  RRScreenFontPrint(date);
  RRScreenFontLocate(90+1, 180);
  RRScreenFontPrint(time);
  RRScreenFontLocate(10  , 150-1);
  RRScreenFontPrint(date);
  RRScreenFontLocate(90  , 180-1);
  RRScreenFontPrint(time);
  RRScreenFontLocate(10  , 150+1);
  RRScreenFontPrint(date);
  RRScreenFontLocate(90  , 180+1);
  RRScreenFontPrint(time);
  RRScreenGCColor(0xe000, 0xe000, 0xf800);
  RRScreenFontLocate(10, 150);
  RRScreenFontPrint(date);
  RRScreenFontLocate(90, 180);
  RRScreenFontPrint(time);
}


/* -------------------------------------------------------------
  update_graphic  -- ʸɽΰɤĤ֤
-------------------------------------------------------------- */
void  update_graphic(void)
{
  GdkPixmap *screen_buf;

  screen_buf = RRScreenBuffer();
  gdk_gc_set_clip_mask(RRScreenGCGet(), NULL);
  gdk_gc_set_clip_origin(RRScreenGCGet(), 0, 120);
  gdk_draw_pixmap(screen_buf, RRScreenGCGet(), pic[face], 0, 120,
		  0, 120, 200, 101);
  disp_time();
}


